;;; install-packages --- Install required packages

;;; Commentary:

;; Install the required packages.

;;; Code:

(require 'package) ;; You might already have this line
(add-to-list 'package-archives
             '("melpa" . "http://melpa.org/packages/"))
(add-to-list 'package-archives
             '("melpa" . "http://melpa.milkbox.net/packages/"))
(when (< emacs-major-version 24)
  ;; For important compatibility libraries like cl-lib
  (add-to-list 'package-archives '("gnu" . "http://elpa.gnu.org/packages/")))
(package-initialize) ;; You might already have this line

(package-refresh-contents)

(package-install '2048-game)
(package-install 'async)
(package-install 'auctex)
(package-install 'auto-complete)
(package-install 'company)
(package-install 'company-auctex)
(package-install 'company-c-headers)
(package-install 'company-dict)
(package-install 'company-jedi)
(package-install 'company-math)
(package-install 'company-web)
(package-install 'cython-mode)
(package-install 'dash)
(package-install 'dash-functional)
(package-install 'diffview)
(package-install 'fish-mode)
(package-install 'flycheck)
(package-install 'flycheck-color-mode-line)
(package-install 'flycheck-pos-tip)
(package-install 'helm)
(package-install 'helm-bibtex)
(package-install 'helm-core)
(package-install 'helm-flycheck)
(package-install 'helm-flyspell)
(package-install 'helm-ls-git)
(package-install 'helm-projectile)
(package-install 'helm-spotify)
(package-install 'hydandata-light-theme)
(package-install 'java-imports)
(package-install 'java-snippets)
(package-install 'javadoc-lookup)
(package-install 'jedi)
(package-install 'jedi-core)
(package-install 'js-comint)
(package-install 'json-mode)
(package-install 'json-reformat)
(package-install 'magit)
(package-install 'magit-popup)
(package-install 'markdown-mode)
(package-install 'math-symbol-lists)
(package-install 'php-mode)
(package-install 'powerline)
(package-install 'projectile)
(package-install 'python-mode)
(package-install 'solarized-theme)
(package-install 'sr-speedbar)
(package-install 'visual-fill-column)
(package-install 'web-mode)
(package-install 'yaml-mode)
(package-install 'yasnippet)

;;; install-packages.el ends here
